% Matlab program to test the simultaneously measuring on 2 channels,

%clear all;
%close all;
%figure(1);
%warning off;
addpath ./bin;
addpath ./MAC;
%addpath .\WINDOWS;
%addpath ./LINUX;
%warning on;

NFT=2048; NF=NFT/2+1;
NFT=1024; NF=NFT/2+1;
Fs=48000; Ts=1/Fs;
Fmax=Fs/2; Fmin=Fs/NFT;
f=Fmin*(0:NF-1); t=Ts*(0:NFT-1);
G=0;

global V,G; V=struct( 'Fs',Fs, 'NFT',NFT, 'f',f, 't',t); 



%Basic parameters for g7play
Nmax=2^31-1;
%Navg=128; %This must be a power of 2, for ola() to work!
%Navg=32; %This must be a power of 2, for ola() to work!
%Navg=8; %This must be a power of 2, for ola() to work!
Navg=32; %This must be a power of 2, for ola() to work!

%Generate chirp for left and right channels
fee=(0:NF-1)/(NF-1);
fee=(NFT/2)*pi*fee.*fee;
%fee=(NFT/pi)*pi*fee.*fee; %Interesting
C=exp(-i*fee);
%C=exp(i*fee); %Time reversed
c=fsst(C); %clear R fee;
c=0.999*c/max(abs(c)); %normalize to abs-peak less 0.1%
C=fast(c);

%zero out chirp harmonics by 2:1
%ke=1:2:length(f)-1; ko=2:2:length(f);
L=C; %L(ko)=0; %zero Even freqs (0, 2fmin, 4fmin, ....)
R=C; %R(ke)=0;   %zero Odd freqs (fmin, 3fmin, 5fmin, ....)
l=fsst(L); r=fsst(R);

%Scale data to int32 2^31-1 range
%l=round(l*Nmax);
G=0.01;% set output
Gr=G; %Gr=0; %Overall gain
Gl=G; %Gl=0;
l=round(Gl*l*Nmax);
r=round(Gr*r*Nmax);
sprintf('Gains %d $d',l,r);

% figure(3)
% subplot(211)
% ylabel('volts')
% plot(l/Nmax)
% ylabel('volts')
% subplot(212)
% plot(r/Nmax)

%save the data in files stim0 and stim1
fd=fopen('data/stim0','w');
N=fwrite(fd,l,'int32'); %Scale to Nmax (32 bit integer)
fclose(fd);

fd=fopen('data/stim1','w');
N=fwrite(fd,r,'int32'); %Scale to Nmax (32 bit integer)
fclose(fd);
delete data/resp0 data/resp1
%for k=1:5 %Loop over measurement
k=1;

%Play chirps via the hand-held  (the main act!)
disp('chirp via handheld');
%analog=sprintf('g7play -Q 0 -B %d -R0 data/stim0 -R1 data/stim1 -c0 data/resp0 -C1 data/resp1 -S %d ',Navg,NFT);
%Use c3 flags set
analog=sprintf('g7play -y alo,blo,ppon,mboff,mpoff,mlo,auxoff -Q 0 -B %d -R0 data/stim0 -R1 data/stim1 -c0 data/resp0 -C1 data/resp1 -S %d ',Navg,NFT);
%analog=sprintf('g7play -Q 0 -B %d -s 4096 -f 1000 -C0 data/resp0 -C1 data/resp1 -S %d >./tmp/g7message.txt',Navg,NFT);
disp(analog); 
system(analog);

%Play tones via the hand-help (support function)
% disp('tone via handheld'); 
% tone=sprintf('g7play -Q 1 -B %d -c0 resp0 -C1 resp1 -S %d >./tmp/g7message.txt',Navg,NFT); 
% disp(tone); 
% system(tone);

%Loopback modes:
%disp('tone loopback'); toneloopback=sprintf('g7play -l client -Q 1 -B %d -c0 resp0 -C1 resp1 -S %d >./tmp/g7message.txt',Navg,NFT); disp(toneloopback); system(toneloopback);

%disp('chirp via handheld'); analog=sprintf('g7play -l client -Q 1 -B %d -R0 stim0 -R1 stim1 -c0 resp0 -C1 resp1 -S %d >./tmp/g7message.txt',Navg,NFT); disp(analog); system(analog);

rd1; %graphics
%hold on;
%grid on
%ylim([1e2 1e3]);
%xlim([50 3e4]);
%drawnow;
%pause(1)
%end %for k=1...
%hold off
%pause
%close all

